Index: FCKeditor/trunk/_whatsnew.html
===================================================================
--- FCKeditor/trunk/_whatsnew.html	(revision 4249)
+++ FCKeditor/trunk/_whatsnew.html	(revision 4250)
@@ -45,25 +45,25 @@
 		<li><strong>Security release, upgrade is highly recommended</strong> (fixed security issues in ASP and ColdFusion scripts).
 			</li>
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2856">#2856</a>] Fixed 
-			problem with inches in paste dialog.</li> 
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3120">#3120</a>] 
-			# (pound sign) is not correctly escaped in file urls</li>
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2915">#2915</a>] 
-			About plugin shows misleading user language</li>
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2856">#2856</a>] Fixed
+			problem with inches in paste dialog.</li>
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3120">#3120</a>]
+			# (pound sign) is not correctly escaped in file urls.</li>
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2915">#2915</a>]
+			About plugin shows misleading user language.</li>
 		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2821">#2821</a>] Configuration
 			items that used floating point numbers were parsed as integers.</li>
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2604">#2064</a>] The asp 
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2604">#2064</a>] The asp
 			connector didn't work correctly in windows 2000 servers.</li>
 		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3429">#3429</a>] Fixed
 			problem in IE8 with XHTML doctype. Thanks to duncansimey.</li>
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3446">#3446</a>] Fixed self-closed  
- 			&lt;option&gt; in the table cell dialog.</li> 
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3181">#3181</a>] Node selection  
-			could raise an error in IE8.</li> 
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2156">#2156</a>]  
-			After calling GetData() the style removal operations didn't work in IE. Thanks to 
-			Compendium Blogware</li> 
-	  <li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3427">#3427</a>] Improved 
- 			compatibility of Document properties dialog with Eclipse.</li> 
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3446">#3446</a>] Fixed self-closed
+ 			&lt;option&gt; in the table cell dialog.</li>
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3181">#3181</a>] Node selection
+			could raise an error in IE8.</li>
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2156">#2156</a>]
+			After calling GetData() the style removal operations didn't work in IE. Thanks to
+			Compendium Blogware.</li>
+	  <li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3427">#3427</a>] Improved
+ 			compatibility of Document properties dialog with Eclipse.</li>
 		<li>Language file updates for the following languages:
 			<ul>
@@ -79,5 +79,5 @@
 		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3880">#3880</a>] Fixed some minor
 			logical and typing mistakes in fckdomrange_ie.js.</li>
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2689">#2689</a>] If a  
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2689">#2689</a>] If a
 			custom connector tried to use the "url" attribute for files it was always reencoded.</li>
 		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/1537">#1537</a>] Fixed extra
@@ -93,12 +93,12 @@
  		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3925">#3925</a>] Removed obsolete
  			parentWindow reference from FCKDialog.OpenDialog().</li>
- 		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2936">#2936</a>] Added protection 
-			in the PHP upload if the destination folder is placed at the root and doesn't exit .</li>
+ 		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2936">#2936</a>] Added protection
+			in the PHP upload if the destination folder is placed at the root and doesn't exit.</li>
  		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/4357">#4357</a>] Avoid problem in
 			the paste dialog if IIS is set to process HTML files as Asp.</li>
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2201">#2201</a>] Fixed a crash in IE 
- 			in an object is selected (with handles) on unload of the editor.</li> 	
-		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3053">#3053</a>] Fixed problems with 
-			the height of the content area in Safari and Chrome.</li> 
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/2201">#2201</a>] Fixed a crash in IE
+ 			in an object is selected (with handles) on unload of the editor.</li>
+		<li>[<a target="_blank" href="http://dev.fckeditor.net/ticket/3053">#3053</a>] Fixed problems with
+			the height of the content area in Safari and Chrome.</li>
 	</ul>
 	<p>
Index: FCKeditor/trunk/editor/_source/commandclasses/fcktextcolorcommand.js
===================================================================
--- FCKeditor/trunk/editor/_source/commandclasses/fcktextcolorcommand.js	(revision 4249)
+++ FCKeditor/trunk/editor/_source/commandclasses/fcktextcolorcommand.js	(revision 4250)
@@ -194,5 +194,5 @@
 
 		FCKTools.AddEventListenerEx( oDiv, 'click', FCKTextColorCommand_MoreOnClick, this ) ;
-	
+
 		// Dirty hack for Opera, Safari and Firefox 3.
 		if ( !FCKBrowserInfo.IsIE )
Index: FCKeditor/trunk/editor/_source/internals/fck_gecko.js
===================================================================
--- FCKeditor/trunk/editor/_source/internals/fck_gecko.js	(revision 4249)
+++ FCKeditor/trunk/editor/_source/internals/fck_gecko.js	(revision 4250)
@@ -382,5 +382,5 @@
 		while ( currentNode && currentNode.nodeType != 1 )
 			currentNode = currentNode.nextSibling ;
-		
+
 		if ( currentNode && FCKListsLib.BlockElements[ currentNode.nodeName.toLowerCase() ] )
 			range.SplitBlock() ;
Index: FCKeditor/trunk/editor/_source/internals/fck_ie.js
===================================================================
--- FCKeditor/trunk/editor/_source/internals/fck_ie.js	(revision 4249)
+++ FCKeditor/trunk/editor/_source/internals/fck_ie.js	(revision 4250)
@@ -176,5 +176,5 @@
 	// If the span is the only child of a node (so the inserted HTML is beyond that),
 	// remove also that parent that isn't needed. #1537
-	if (fake.parentNode.childNodes.length == 1) 
+	if (fake.parentNode.childNodes.length == 1)
 		fake = fake.parentNode ;
 	fake.removeNode( true ) ;
Index: FCKeditor/trunk/editor/_source/internals/fckdomtools.js
===================================================================
--- FCKeditor/trunk/editor/_source/internals/fckdomtools.js	(revision 4249)
+++ FCKeditor/trunk/editor/_source/internals/fckdomtools.js	(revision 4250)
@@ -489,22 +489,22 @@
 		for ( var i = 0 ; i < attributes.length ; i++ )
 		{
-			if ( FCKBrowserInfo.IsIE ) 
+			if ( FCKBrowserInfo.IsIE )
 			{
 				var attributeNodeName = attributes[i].nodeName ;
 
-				if ( attributeNodeName.StartsWith( '_fck' ) ) 
+				if ( attributeNodeName.StartsWith( '_fck' ) )
 				{
 					/**
 					 * There are places in the FCKeditor code where HTML element objects
-					 * get values stored as properties (e.g. _fckxhtmljob).  In Internet 
+					 * get values stored as properties (e.g. _fckxhtmljob).  In Internet
 					 * Explorer, these are interpreted as attempts to set attributes on
-					 * the element.  
+					 * the element.
 					 *
 					 * http://msdn.microsoft.com/en-us/library/ms533026(VS.85).aspx#Accessing_Element_Pr
 					 *
-					 * Counting these as HTML attributes cripples 
+					 * Counting these as HTML attributes cripples
 					 * FCK.Style.RemoveFromRange() once FCK.GetData() has been called.
 					 *
-					 * The above conditional prevents these internal properties being 
+					 * The above conditional prevents these internal properties being
 					 * counted as attributes.
 					 *
@@ -515,5 +515,5 @@
 				}
 
-				if ( attributeNodeName == 'class' ) 
+				if ( attributeNodeName == 'class' )
 				{
 					// IE has a strange bug. If calling removeAttribute('className'),
Index: FCKeditor/trunk/editor/_source/internals/fckscayt.js
===================================================================
--- FCKeditor/trunk/editor/_source/internals/fckscayt.js	(revision 4249)
+++ FCKeditor/trunk/editor/_source/internals/fckscayt.js	(revision 4250)
@@ -34,6 +34,6 @@
 
 		isEngineLoaded = true ;
-		
-		var init = function () 
+
+		var init = function ()
 		{
 			scayt = top.scayt ;
@@ -43,5 +43,5 @@
 			InitSetup() ;
 		};
-		
+
 		if ( top.scayt )
 		{
@@ -49,5 +49,5 @@
 			return ;
 		}
-			
+
 		// Compose the scayt url.
 		if (FCK.Config.ScaytCustomUrl)
@@ -65,14 +65,14 @@
 			baseUrl : scaytConfigBaseUrl,
 			addOnLoad : function()
-			{ 
+			{
 				init();
 			},
 			isDebug : false
 		};
-		
-		
+
+
 		if ( callback )
 			scaytOnLoad.push( callback ) ;
-		
+
 		DoLoadScript( scaytUrl ) ;
 	}
@@ -115,5 +115,5 @@
 		var scayt = window.scayt;
 		var scayt_control = window.scayt_control = new scayt( oParams ) ;
-		
+
 		if ( scayt_control )
 		{
@@ -158,9 +158,9 @@
 					break;
 				}
-					
+
 				if ( isEngineLoaded && scaytReady )
 					FCKDialog.OpenDialog( 'Scayt', 'SCAYT Settings', 'dialog/fck_scayt.html?' + action.toLowerCase(), 343, 343 );
 				break;
-				
+
 			default :
 				if ( !isEngineLoaded )
@@ -171,5 +171,5 @@
 							me.SetEnabled( !scayt_control.disabled ) ;
 						}) ;
-					
+
 					return true;
 				}
@@ -192,6 +192,6 @@
 		if ( !scaytReady )
 			return ScaytMessage( 'SCAYT is not ready' ) || false;
-		
-		
+
+
 		return true;
 	}
@@ -201,5 +201,5 @@
 		window.scayt_control.setDisabled( false ) ;
 		scaytEnable = true;
-		
+
 	}
 
@@ -220,5 +220,5 @@
 		return true;
 	}
-	
+
 	ScaytCommand.prototype.GetState = function()
 	{
@@ -293,10 +293,10 @@
 		m && alert( m ) ;
 	}
-	
+
 	var ScaytContextCommand = function()
 	{
 		name = 'ScaytContext' ;
 	}
-	
+
 	ScaytContextCommand.prototype.Execute = function( contextInfo )
 	{
@@ -361,5 +361,5 @@
 
 					menu.AddSeparator() ;
-					
+
 					menu.AddItem( 'ScaytContext', 'Ignore', null, false, { action : 'Ignore', node : node } );
 					menu.AddItem( 'ScaytContext', 'Ignore All', null, false, { action : 'Ignore All', node : node } );
@@ -369,5 +369,5 @@
 						if (scaytReady && scaytEnable)
 							scayt_control.fireOnContextMenu( null, FCK.ContextMenu._InnerContextMenu);
-						
+
 					}
 					catch( err ) {}
Index: FCKeditor/trunk/editor/_source/internals/fckxhtml.js
===================================================================
--- FCKeditor/trunk/editor/_source/internals/fckxhtml.js	(revision 4249)
+++ FCKeditor/trunk/editor/_source/internals/fckxhtml.js	(revision 4250)
@@ -58,15 +58,15 @@
 
 	/**
-	 * FCKXHtml._AppendNode() marks DOM element objects it has 
-	 * processed by adding a property called _fckxhtmljob, 
-	 * setting it equal to the value of FCKXHtml.CurrentJobNum.  
-	 * On Internet Explorer, if an element object has such a 
-	 * property,  it will show up in the object's attributes 
-	 * NamedNodeMap, and the corresponding Attr object in 
-	 * that collection  will have is specified property set 
-	 * to true.  This trips up code elsewhere that checks to 
-	 * see if an element is free of attributes before proceeding 
+	 * FCKXHtml._AppendNode() marks DOM element objects it has
+	 * processed by adding a property called _fckxhtmljob,
+	 * setting it equal to the value of FCKXHtml.CurrentJobNum.
+	 * On Internet Explorer, if an element object has such a
+	 * property,  it will show up in the object's attributes
+	 * NamedNodeMap, and the corresponding Attr object in
+	 * that collection  will have is specified property set
+	 * to true.  This trips up code elsewhere that checks to
+	 * see if an element is free of attributes before proceeding
 	 * with an edit operation (c.f. FCK.Style.RemoveFromRange())
-	 *	
+	 *
 	 * refs #2156 and #2834
 	 */
Index: FCKeditor/trunk/editor/_source/internals/fckxhtml_ie.js
===================================================================
--- FCKeditor/trunk/editor/_source/internals/fckxhtml_ie.js	(revision 4249)
+++ FCKeditor/trunk/editor/_source/internals/fckxhtml_ie.js	(revision 4250)
@@ -96,5 +96,5 @@
  * Used to clean up HTML that has been processed FCKXHtml._AppendNode().
  *
- * For objects corresponding to HTML elements, Internet Explorer will 
+ * For objects corresponding to HTML elements, Internet Explorer will
  * treat a property as if it were an attribute set on that element.
  *
@@ -110,5 +110,5 @@
  */
 
-FCKXHtml._RemoveXHtmlJobProperties = function ( node ) 
+FCKXHtml._RemoveXHtmlJobProperties = function ( node )
 {
 	// Select only nodes of type ELEMENT_NODE
@@ -121,8 +121,8 @@
 
 	// Recurse upon child nodes.
-	if ( node.hasChildNodes() ) 
+	if ( node.hasChildNodes() )
 	{
 		var childNodes = node.childNodes ;
-		for ( var i = childNodes.length - 1 ; i >= 0 ; i-- ) 
+		for ( var i = childNodes.length - 1 ; i >= 0 ; i-- )
 			FCKXHtml._RemoveXHtmlJobProperties( childNodes.item(i) ) ;
 	}
Index: FCKeditor/trunk/editor/dialog/fck_scayt.html
===================================================================
--- FCKeditor/trunk/editor/dialog/fck_scayt.html	(revision 4249)
+++ FCKeditor/trunk/editor/dialog/fck_scayt.html	(revision 4250)
@@ -48,13 +48,13 @@
 				"dic_rename,dic_delete"
 			];
-			
-			var get = 
+
+			var get =
 				new function(){
-				 	
+
 					var mergeObjs = function(obj1, obj2)
 					{
 						for (var k in obj1)
 							obj2[k] = obj1[k];
-								
+
 						return obj2;
 					};
@@ -65,13 +65,13 @@
 						return s ;
 					};
-					
+
 					var addEvent = function( el ,sEventName, fTodo )
 					{
 						if (el.addEventListener) {
 							el.addEventListener (sEventName,fTodo,false);
-							
+
 						} else if (el.attachEvent) {
 							el.attachEvent ("on"+sEventName,fTodo);
-							
+
 						} else {
 							el["on"+sEventName] = fTodo;
@@ -113,5 +113,5 @@
 						}
 					};
-					
+
 					var hasClassName = function ( sClassName, elem ) {
 						//.split(/\s+/);
@@ -123,5 +123,5 @@
 						return false;
 					}
-						
+
 					var single = {
 						addClass 	: function ( sClassName ) {
@@ -132,5 +132,5 @@
 							this.className = s;
 							return this;
-							
+
 						},
 						removeClass : function ( sClassName ) {
@@ -161,5 +161,5 @@
 							if ( !sAttrName )
 								return null;
-							
+
 							return this[sAttrName];
 						},
@@ -168,5 +168,5 @@
 							if ( !sAttrName || !attrVal )
 								return null;
-							
+
 							this[sAttrName] = attrVal;
 
@@ -175,9 +175,9 @@
 						remAttr : function ( sAttrName )
 						{
-							if ( !sAttrName ) 
+							if ( !sAttrName )
 								return null;
 						}
 					};
-						
+
 					var singleCaller = function ( sMethod,args ) {
 						for ( var i=0, l=this.length; i<l ; i++ ){
@@ -186,8 +186,8 @@
 						}
 					};
-					
-					
+
+
 					var collection = {
-						
+
 						addClass 	: function ( sClassName ){
 							singleCaller.call(this, "addClass", [sClassName])
@@ -210,5 +210,5 @@
 							return this;
 						},
-						
+
 						forEach : function ( fTodo ) {
 							//el,i
@@ -218,19 +218,19 @@
 							return this;
 						}
-						
-					};
-					
-					
-					
+
+					};
+
+
+
 					this.byClass = function( sClassName ){
 						var o = getElementsByClassName(document, sClassName );
 						return o ? mergeObjs( collection, o ) : o;
 					};
-					
+
 					this.byId = function( sId ){
 						var o = document.getElementById( sId );
 						return o ? mergeObjs( single, o ) : o;
 					};
-					
+
 					this.gup = function ( name ){
 				        name = name.replace( /[\[]/, '\\\[' ).replace( /[\]]/, '\\\]' ) ;
@@ -238,5 +238,5 @@
 				        var regex = new RegExp( regexS ) ;
 				        var results = regex.exec( window.location.href ) ;
-				        
+
 				        if( results == null )
 				            return '' ;
@@ -250,9 +250,9 @@
 						collection.forEach.apply( oScope,[fTodo] );
 					};
-					
+
 				 };
-			
-			
-			
+
+
+
 			// Add the dialog tabs.
 			tabs[0] == 1 && dialog.AddTab( 'options', 'Options' ) ;
@@ -260,5 +260,5 @@
 			tabs[2] == 1 && dialog.AddTab( 'dictionary', 'Dictionary' ) ;
 			tabs[3] == 1 && dialog.AddTab( 'about', 'About' ) ;
-			
+
 			// Function called when a dialog tab is selected.
 			function OnDialogTabChange( tabCode )
@@ -269,26 +269,26 @@
 				ShowE('inner_about'	, ( tabCode == 'about' ) ) ;
 			}
-			
-			
-			
-				
-				
+
+
+
+
+
 			window.onload = function()
 			{
 				// Things to do when the page is loaded.
-			
+
 				if ( document.location.search.length )
 					dialog.SetSelectedTab( document.location.search.substr(1) ) ;
-			
+
 				dialog.SetOkButton( true ) ;
-				
-	                
+
+
 	                if (!scayt) throw "SCAYT is undefined";
 	                if (!scayt_control) throw "SCAYT_CONTROL is undefined";
-					
+
 					// show alowed tabs
 					tabs = scayt_control.uiTags || [1,1,1,0];
-					
-					
+
+
 					sLang = scayt_control.getLang();
 	                fckLang = "en";
@@ -302,14 +302,14 @@
 						//lang_list = scayt.getLangList();
 		                lang_list = scayt.getLangList() ;//|| {ltr: {"en_US" : "English","en_GB" : "British English","pt_BR" : "Brazilian Portuguese","da_DK" : "Danish","nl_NL" : "Dutch","en_CA" : "English Canadian","fi_FI" : "Finnish","fr_FR" : "French","fr_CA" : "French Canadian","de_DE" : "German","el_GR" : "Greek","hu_HU" : "Hungarian","it_IT" : "Italian","nb_NO" : "Norwegian","pl_PL" : "Polish","pt_PT" : "Portuguese","ru_RU" : "Russian","es_ES" : "Spanish","sv_SE" : "Swedish","tr_TR" : "Turkish","uk_UA" : "Ukrainian","cy_GB" : "Welsh"},rtl: {"ar_EG" : "Arabic"}};
-		                
-		                
-		                   
-		                
+
+
+
+
 		                // ** animate options
 		                get.byClass("_scayt_option").forEach(function(el,i){
-		                    
+
 							if ('undefined' != typeof(options[el.name])) {
 		                        // *** set default values
-								
+
 		                        if ( 1 == options[ el.name ] ){
 		                           //el.setAttribute("checked","true");
@@ -322,10 +322,10 @@
 		                        // *** bind events
 		                        get.wrap(el).bindOnclick( function(ev){
-									
+
 									var that = get.wrap(this);
 									var isCheck = that.getAttr("checked");
-									//console.info(isCheck)									
+									//console.info(isCheck)
 		                            if ( isCheck == false ) {
-		                                
+
 										//that.setAttr("checked",false);
 										options[ this.name ] = 0;
@@ -338,10 +338,10 @@
 		                    }
 		                });
-						
-						
+
+
 		                // * Create languages tab
 		                // ** convert langs obj to array
 		                var lang_arr = [];
-		                
+
 		                for (var k in lang_list.rtl){
 		                    // find curent lang
@@ -349,5 +349,5 @@
 		                        chosed_lang = lang_list.rtl[k] + "::" + k;
 		                    lang_arr[lang_arr.length] = lang_list.rtl[k] + "::" + k;
-		                        
+
 		                }
 		                for (var k in lang_list.ltr){
@@ -358,15 +358,15 @@
 		                }
 		                lang_arr.sort();
-		                
+
 		                // ** find lang containers
-		                
+
 		                var lcol = get.byId("lcolid");
 		                var rcol = get.byId("rcolid");
 		                // ** place langs in DOM
-						
+
 		                get.forEach(lang_arr , function( l , i ){
-		                    
+
 							//console.info( l,i );
-							
+
 							var l_arr = l.split('::');
 		                    var l_name = l_arr[0];
@@ -377,5 +377,5 @@
 		                    // split langs on half
 		                    var col = ( i < lang_arr.length/2 ) ? lcol:rcol ;
-		                    
+
 		                    // append row
 		                    //console.dir( col )
@@ -383,5 +383,5 @@
 		                    var row_dom = get.byId( l_code )
 		                    row_dom.innerHTML = l_name;
-		                    	                    
+
 		                    var checkActiveLang = function( id ){
 		                        return chosed_lang.split("::")[1] == id;
@@ -389,5 +389,5 @@
 		                    // bind click
 		                    row_dom.bindOnclick(function(ev){
-		                        
+
 		                        if ( checkActiveLang(this.id) ) return false;
 		                        var elId = this.id;
@@ -395,12 +395,12 @@
 	                            	.addClass("Button")
 	                            	.removeClass("DarkBackground");
-		                            
+
 		                        window.setTimeout( function (){ get.byId(elId).setStyle({opacity:"0.5",cursor:"no-drop"});  } ,300 );
-		                        
+
 		                        get.byId(chosed_lang.split("::")[1])
 		                            .addClass("DarkBackground")
 		                            .removeClass("Button")
 		                            .setStyle({opacity:"1",cursor:"pointer"});
-		                            
+
 		                        chosed_lang = this.innerHTML + "::" + this.id;
 		                        return true;
@@ -412,41 +412,41 @@
 		                    if (l == chosed_lang)
 		                        row_dom.addClass("Button").setStyle({opacity:"0.5",cursor:"no-drop"});
-		                    else 
+		                    else
 		                        row_dom.addClass("DarkBackground").setStyle({opacity:"1"});
-		                        
+
 		                });
-						// * user dictionary    
+						// * user dictionary
 						if ( userDicActive ){
 							initUserDictionary()
-										
+
 						}
 					});
-					
-					
-					
-			}
-			
-			
-			
-			
+
+
+
+			}
+
+
+
+
 			var buttons = [ 'dic_create','dic_delete','dic_rename','dic_restore' ];
 			var labels  = [ 'mixedCase','mixedWithDigits','allCaps','ignoreDomainNames' ];
-			
-			
-			function apllyCaptions ( ) 
-			{
-				
+
+
+			function apllyCaptions ( )
+			{
+
 				// fill tabs headers
 				// add missing captions
-				
+
 				get.byClass("PopupTab").forEach(function(el,i){
-					
+
 					if ( tabs[i] == 1 ){
 						el.style.display = "block";
 					}
 					el.innerHTML = captions['tab_'+el.id];
-					
+
 				});
-					
+
 				// Fill options labels.
 				for ( i in labels )
@@ -454,5 +454,5 @@
 					var label = 'label_' + labels[ i ],
 						labelElement = document.getElementById( label );
-					
+
 					if (  'undefined' != typeof labelElement
 					   && 'undefined' != typeof captions[ label ] && captions[ label ] !== ""
@@ -472,17 +472,17 @@
 				get.byId("dname").innerHTML = captions['label_dname'];
 				get.byId( 'dic_info' ).innerHTML = captions[ 'dic_info' ];
-					
+
 				// fill about tab
 				var about = '<p>' + captions[ 'about_throwt_image' ] + '</p>'+
 					'<p>' + captions[ 'version' ]  + scayt.version.toString() + '</p>' +
 					'<p>' + captions[ 'about_throwt_copy' ] + '</p>';
-				
-				get.byId( 'scayt_about' ).innerHTML = about;	
-			
-			}
-			
-			
+
+				get.byId( 'scayt_about' ).innerHTML = about;
+
+			}
+
+
 			function initUserDictionary () {
-				
+
 				scayt.getNameUserDictionary(
 					function( o )
@@ -496,5 +496,5 @@
 						else
 							display_dic_buttons( dic_buttons[0] );
-		
+
 					},
 					function ()
@@ -504,10 +504,10 @@
 					}
 				);
-					
+
 				dic_success_message("");
-				
+
 				 // ** bind event listeners
                 get.byClass("button").bindOnclick(function( ){
-					
+
 					// get dic name
 					var dic_name = get.byId('dic_name').value ;
@@ -519,11 +519,11 @@
 					//apply handler
 					window[this.id].apply( window, [this, dic_name, dic_buttons ] );
-						
+
 					//console.info( typeof window[this.id], window[this.id].calle )
 					return false;
-				});			
-			
-			}
-			
+				});
+
+			}
+
 			dic_create = function( el, dic_name , dic_buttons )
 			{
@@ -638,5 +638,5 @@
             function dic_success_message( m )
             {
-				if ( !m ) 
+				if ( !m )
 					return ;
 
@@ -662,5 +662,5 @@
 				get.byId("dic_tab").style.display = "block";
 			}
-			
+
 			function Ok()
 			{
@@ -671,5 +671,5 @@
 				//console.info(options)
 			    for ( var oN in options ) {
-					
+
 			        if ( o[oN] != options[oN] && c == 0){
 						//console.info( "set option " )
@@ -685,9 +685,9 @@
 			        c++;
 			    }
-			    
-			    if ( c > 0 )  scayt_control.refresh();   
-			    
+
+			    if ( c > 0 )  scayt_control.refresh();
+
 			    return dialog.Cancel();
-				
+
 			}
 
@@ -696,5 +696,5 @@
 	<body style="OVERFLOW: hidden" scroll="no">
 		<div class="tab_container" id="inner_options">
-		   
+
            <ul id="scayt_options">
                <li class="_scayt_options">
@@ -714,15 +714,15 @@
                    <label for="mixedWithDigits" id="label_mixedWithDigits"></label>
                </li>
-           </ul> 
+           </ul>
 		</div>
 		<div class="tab_container" id="inner_langs">
-		   
+
 		   <div class="lcol" id="lcolid"></div>
            <div class="rcol" id="rcolid"></div>
 		</div>
 		<div class="tab_container" id="inner_dictionary">
-		   		   
+
 		   <div id="dic_message"></div>
-			<div id="_off_dic_tab" class="dictionary" > 
+			<div id="_off_dic_tab" class="dictionary" >
 				<div style="padding-left:10px;">
 							<label id="dname" for="dname"></label>
@@ -735,7 +735,7 @@
 							<a href="#" id="dic_restore" class="button">  </a>
 						</div>
-						
+
 						<div id="dic_info"></div>
-				
+
 			</div>
 		</div>
Index: FCKeditor/trunk/editor/dialog/fck_scayt/scayt_dialog.css
===================================================================
--- FCKeditor/trunk/editor/dialog/fck_scayt/scayt_dialog.css	(revision 4249)
+++ FCKeditor/trunk/editor/dialog/fck_scayt/scayt_dialog.css	(revision 4250)
@@ -141,5 +141,5 @@
 	border: #d5d59d 1px solid;
 	padding: 2px 4px;
-	margin-right: 4px; 
+	margin-right: 4px;
 	text-decoration: none;
 }
@@ -149,5 +149,5 @@
 a.button:visited{
 	padding: 2px 4px;
-	margin-right: 4px; 
+	margin-right: 4px;
 	text-decoration: none;
 }
Index: FCKeditor/trunk/editor/filemanager/connectors/cfm/cf5_upload.cfm
===================================================================
--- FCKeditor/trunk/editor/filemanager/connectors/cfm/cf5_upload.cfm	(revision 4249)
+++ FCKeditor/trunk/editor/filemanager/connectors/cfm/cf5_upload.cfm	(revision 4250)
@@ -233,5 +233,5 @@
 		<cfset sTempDir = GetTempDirectory()>
 	</cfif>
-	
+
 	<!--- first upload the file with an unique filename --->
 	<cffile action="upload"
Index: FCKeditor/trunk/editor/filemanager/connectors/perl/config.pl
===================================================================
--- FCKeditor/trunk/editor/filemanager/connectors/perl/config.pl	(revision 4249)
+++ FCKeditor/trunk/editor/filemanager/connectors/perl/config.pl	(revision 4250)
@@ -38,3 +38,2 @@
 "Media", "aiff|asf|avi|bmp|fla|flv|gif|jpeg|jpg|mid|mov|mp3|mp4|mpc|mpeg|mpg|png|qt|ram|rm|rmi|rmvb|swf|tif|tiff|wav|wma|wmv"
 );
-